QUnit.test('peteshow dom setup', function(assert) {
  assert.equal(1, $('form').length, 'form exists')
  assert.equal(1, $('#peteshow').length, 'peteshow exists')
});

QUnit.test('fill out form functionality', function(assert) {
  Peteshow.fillOutForms();

  NUMBER_REGEX        = /^[0-9]*$/
  TEXT_REGEX          = /^[a-zA-Z0-9.,\/_ -]+$/
  EMAIL_REGEX         = /^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,6}$/i
  DATE_REGEX          = /^\d{2}([\//-])\d{2}\1\d{4}$/
  PHONE_NUMBER_REGEX  = /\(\d{3}\)\d{3}-\d{4}/

  // from plugin
  assert.equal('PL25 3JR', $('input[name*=zip]').val(), 'rule loaded from plugin, string');
  assert.equal(true, TEXT_REGEX.test($('input[name*=county]').val()), 'rule loaded from plugin, function');

  // from defaults
  var fields = {
    'input[type=password]'                        : 'password',
    'input[type=text]'                            : TEXT_REGEX,
    'input[type=email], input[name*=email]'       : EMAIL_REGEX,
    'input[name*=number], input[type=number]'     : NUMBER_REGEX,
    'input[name*=date]'                           : DATE_REGEX,
    'input[name*=phone]'                          : PHONE_NUMBER_REGEX,
    'input[name*=first_name]'                     : TEXT_REGEX,
    'input[name*=last_name]'                      : TEXT_REGEX,
    'input[name*=company]'                        : TEXT_REGEX,
    'input[name*=street], input[name*=line1]'     : TEXT_REGEX,
    'input[name*=line2], input[name*=suite]'      : TEXT_REGEX,
    'input[name*=city]'                           : TEXT_REGEX,
    'input[name*=state]'                          : TEXT_REGEX,
    'input[name*=job_title]'                      : TEXT_REGEX,
    'input[name*=intent]'                         : TEXT_REGEX,
    'input[name*=income], input[name*=amount]'    : NUMBER_REGEX,
    'input[name*=branch], input[name*=routing]'   : '400001',
    'input[name*=card_type_cd]'                   : '001',
    'input[name*=card_number]'                    : '4111111111111111',
    'input[name*=cvv]'                            : '123',
  }

  $.each(fields, function(k,v) {
    if(v.hasOwnProperty('source'))
      assert.equal(true, v.test($(k).val()), 'testing ' + k + ' regex');
    else
      assert.equal(v, $(k).val(), 'testing ' + k + ' string');
  });
});
